Unit Imain;

Interface

Uses Crt,Novell,Ipxsmall,dos,objects;

const
  Msg   = '/M';          { privatna sprava }
  Msg2  = '/MSG';        { privatna sprava }
  Me    = '/ME';         { upravi spravu na /* nick txt/ }
  Notice= '/NOTICE';     { vypise poznamku }
  WhoIs = '/WHOIS';      { informacie o uzivatelovi }
  Help  = '/HELP';       { vypise zoznam prikazov }

  Urequest = '/UREQEST'; { poziadavka na zistenie uzivatelov }
  Uadd ='/ADD_USER';     { prikaz na pridanie usera do zoznamu }
  Urem ='/REMOVE_USER';  { prikaz na odobratie usera zo zoznamu }
  Unew = '/NEW_USER';    { pridanie usera a vypis ze sa pripojil }

  NormFg    = 11;
  NormBg    = Blue;
  MsgFgC    = White;
  MsgBgC    = Blue;
  SpcCol    = LightGreen;
  NoticeCol = LightRed;
  MeColor   = Yellow;

  Version = 'iChat 1.0.0';

  SendSocket:WORD=$7777; { socket na odosielanie }
  RecvSocket:WORD=$6666; { socket na prijimanie }

type
  Packet = record       { typ paket obsahuje vsetko dolezite... }
             ecb  : ECBType;   { ...ako Event control block... }
             IPX  : IPXheader; { ...ipx hlavicku... }
             data : string;    { ...a samotne data }
           end;

Var  nick      : string[10];         { prezyvka uzivatela - jeho meno }
     y         : integer;            { y-ova suradnica na obrazovke }
     Color     : integer;            { farba textu }
     line      : string;             { obsahuje vstup z klavesnice }
     i,j       : integer;            { pomocne premenne }
     c         : PStringCollection;  { zoznam uzivatelov }
     a         : ^string;            { pointer na string }
     ai        : integer;            { pomocna premenna }
     send,                           { na posielanie staci jeden }
     receive1,                       { na primanie dat treba viac premennych, }
     receive2,                       { aby vzdy jeden bol v dispozicii }
     receive3  : Packet;

procedure GetNick;          { zisti/vypyta si pouzivatelov nick }
procedure UpdateUserWindow; { prekresli zoznam uzivatelov }

procedure WindowBar; { text v nadpise editovacieho okna }
Procedure ShowHelp; {vypise help }
procedure Usage; { info o prg }
procedure InitScreen; { pripravi obrazovku }

function MyUserName:String; { vrati meno pouzivatela - novelacke username }
(* function IntToStr(I: Longint): String; *)
procedure ShowLine(lines : String); { vypise spravu do okna }
Function Dec2Hex(w: Word):String; { konvertuje decimalnu hodnotu do HEX }

function UpWord(str : string) : string; { prevedie retazec na velke pismena }
function Is4You(str : string) : Boolean;

Implementation

Procedure Getnick;
begin
nick:='';
if ParamCount=0 then  { ak nebola zadana prezivka (nick) ako paramenter }
  begin               { pri starte, napr ichat.exe iwik }
    Write('Enter your nick: '); { tak si ju vypytame }
    Readln(nick);
    if nick='' then   { ak uzivatel iba stlaci Enter, pouzije sa jeho }
     begin            { "novelacke" user name }
      nick:=MyUserName;
      i:=pos('.',nick);
      if i>0 then nick:=Copy(nick,1,i-1);
    end;              { if nick='' }
  end                 { if paramcount=0 }
  else
    begin
      for i:=1 to paramcount do { ziskanie mena z prik. riadku  }
      begin
        line:=Paramstr(i); { tu je line len preto aby som setril na premennych}
        if (line[1]<>'-') and (line[1]<>'/') then nick:=nick+Paramstr(i)+' ';
      end;
      delete(nick,length(nick),1);
    end;

  { skonvertovanie medzier (#32) na znak _ }
  for j:=1 to length(nick) do
      if nick[j]=#32 then nick[j]:='_';

end;


procedure UpdateUserWindow;
var temp_y:byte;
begin
temp_y:=Wherey;
Window(66,2,75,17);
ClrScr;  { vymaze iba obsah okna }
TextColor(LightGreen);
for ai:=0 to c^.count-1 do { vypise obsah celej collection }
begin
  a:=c^.at(ai);
  Writeln(a^);
end;
Window(4,2,64,17);
Gotoxy(1,temp_y);
end;

{ UpWord - prevedie retazec na velke pismena }
function UpWord(str : string) : string;
var i : integer; strr : string;
begin
  strr:='';
  for i:=1 to Length(str) do
    strr:=strr+UpCase(str[i]);
  UpWord:=strr;
end;

{ Is4You - vrati True, ak je to pre danu osobu .. }
function Is4You(str : string) : Boolean;
var nickk : string;
begin
  Delete(str,1,Pos(' ',str));
  if Pos(' ',str)=0 then nickk:=str
  else
    nickk:=Copy(str,1,Pos(' ',str)-1);
  if UpWord(nickk)=UpWord(nick) then Is4You:=True else Is4You:=False;
end;

{ ShowLine - zobrazi text do hlavneho okna }
procedure ShowLine(lines : String);
begin
  window(4,2,64,17);
  gotoXY(1,y);
  writeln(lines);
  y:=WhereY;
end;

{ WindowBar - prekresli nadpis editivacieho okna }
procedure WindowBar;
var I : Integer;
begin
  Window(3,2,80,25);
  GotoXY(20,20);
  TextColor(Yellow);
  TextBackground(Blue);
  For I:=1 to 35 do Write(#205);
  GotoXY((71-Length(nick)-1) div 2,20);
  TextColor(White);
  Write(' '+nick+' ');
  TextColor(Yellow);
  Write(#205);
  window(4,2,75,17);
  GotoXY(1,y);
end;

Procedure ShowHelp;
begin
    TextColor(7);
    Showline('');
    Showline('   HELP    ');
    Showline('You can use following commands:');
    Showline('/Whois <nick>    - displays username for supplied nick');
    Showline('/M <user> <text> - write text only to user');
    Showline('/Notice <text>   - write text as notice');
    Showline('/Me <text>       - write text message');
    Showline(' IMPORTANT:  every command must begin with / character !');
    Showline(' ');
    Showline('');
end;

procedure Usage; { info o prg }
begin
 Writeln(Version,#13#10);
 Writeln('IPX chat for Novell');
 WriteLn('Usage: iChat -<options> [nick]'#13#10);
 Writeln('<options>');
 Writeln('help -- this help');
 Halt(0);
end;

procedure CreateWindow(X1,Y1,X2,Y2:Byte;Title:String); { vytvori okienka }
 var I,Attr:Byte;
begin
 Attr:=TextAttr;
 GotoXY(X1,Y1);
 Write(#201);
 GotoXY(X2,Y1);
 Write(#187);
 GotoXY(X1,Y2);
 Write(#200);
 GotoXY(X2,Y2);
 Write(#188);
 for I:=X1+1 to X2-1 do
 begin
  GotoXY(I,Y1);
  Write(#205);
  GotoXY(I,Y2);
  Write(#205);
 end;
 if Title<>'' then
 begin
  GotoXY((X2-X1-Length(Title)-2) div 2,Y1);
  TextColor(White);
  Write(' '+Title+' ');
  TextColor(Yellow);
 end;
 for I:=Y1+1 to Y2-1 do
 begin
  GotoXY(X1,I);
  Write(#186);
  GotoXY(X2,I);
  Write(#186);
 end;
 TextBackground(Black);textColor(8);
 For I:=X1+1 to X2 Do
 begin
  Gotoxy(I,Y2+1);
  Write(#177);
 End;
 For I:=Y1+1 to Y2+1 Do
  begin
  Gotoxy(X2+1,I);
  Write(#177+#177);
 End;
 Window(X1+1,Y1+1,X2-1,Y2-1);
 TextColor(9);TextBackGround(9);
 Clrscr;
 TextColor(15);Writeln;
 TextAttr:=Attr;
 Window(1,1,80,25);
end;

{ Vytvori oddelujucu ciaru medzi hlavny oknom a zoznamom uzivatelov }
procedure CreateDivider(X1,Y1,Y2:Byte);
var I:integer;
begin
 Gotoxy(X1,Y1);
 For i:=Y1 to Y2 do begin Write(#179);Gotoxy(X1,i); end;
 Gotoxy(X1,Y1-1);
 Write(#209);
 Gotoxy(X1,Y2);
 Write(#207);
end;

procedure InitScreen; { pripravi obrazovku }
Var I:Integer;
begin
 Clrscr;
 TextBackground(9);textColor(7);
 For I:=1 to 1920 do write(#177);
 TextColor(14);
 CreateWindow(2,1,76,18,'NETWARE CHAT');
 CreateDivider(65,2,18);
 TextColor(White);
 Gotoxy(67,1);Write(' USERS ');
 TextColor(14);
 CreateWindow(2,21,76,23,''); {edit box}
 GotoXY(1,25);
 TextColor(White);
 TextBackground(5);
 ClrEol;
 Write(' ',Version,' - F1 for help');
 for i:=1 to 37 do Write(#32);
 Write('Created by Iwik ');
 TextBackground(Black);
 Textcolor(15);
 Window(4,22,64,22);
 GotoXY(1,1);
end;

{ MyUserName - vrati novelacke username }
Function MyUserName:String;
var UserName : String;
    RetCode  : Integer;
    Station  : Integer;
begin
 { funkcie z jednotky Novell.pas }
 GetStation(Station,RetCode);
 if retcode=0 then GetUser(Station,UserName,RetCode);
 if (username<>'') or (retcode<>0) then MyUserName:=UserName
 else MyUserName:='anonymous';
end;

{ Dec2Hex - konvertuje decimalne cislo do HEX }
Function Dec2Hex(w: Word):String;
const
 hexChars : array [0..$F] of Char = '0123456789ABCDEF';
var
 result : string;
begin
 result:=hexChars[Hi(w) shr 4]+
         hexChars[Hi(w) and $F]+
         hexChars[Lo(w) shr 4]+
         hexChars[Lo(w) and $F];
 Dec2Hex:=result;
end;


end.
